<?php
error_reporting(0);

require_once 'config/config.php';

$img_src = $_GET['image'];
$x = $_GET['x'];
$y = $_GET['y'];

$cf_max_w = $plugin_cf['tg_popup']['max_img_width'];
$cf_max_h = $plugin_cf['tg_popup']['max_img_height'];
$set_max_size = $plugin_cf['tg_popup']['set_max_size'];
$preserve_orig = $plugin_cf['tg_popup']['preserve_original_img'];

$types = array (1 => "gif", "jpeg", "png", "swf", "psd", "wbmp");

define ('cache', '/cache');

$cachedir = dirname($img_src).cache;
if (!is_dir($cachedir))
mkdir ($cachedir, 0777);
else
system ("chmod 0777 ".$cachedir);

(!isset ($x) || ereg ('^[0-9]{1,}$', $x, $regs)) &&
(!isset ($y) || ereg ('^[0-9]{1,}$', $y, $regs)) &&
(isset ($x) || isset ($y))
? true
: DIE ('Fehlende(r) oder ungültige(r) Größenparameter!');

!isset ($resize) || !ereg ('^[0|1]$', $resize, $regs)
? $resize = 0
: $resize;

!isset ($img_src)
? DIE ('Es wurde kein Bild angegeben!')
: !file_exists($img_src)
? DIE ('Die angegebene Datei konnte nicht auf dem Server gefunden werden!')
: false;

$imagedata = getimagesize($img_src);

$orig_w = $imagedata[0];
$orig_h = $imagedata[1];
$img_type = $types[$imagedata[2]];
$img_type_upper = strtoupper($img_type);

!$imagedata[2] || $imagedata[2] == 4 || $imagedata[2] == 5
? DIE ('Bei der angegebenen Datei handelt es sich nicht um ein Bild!')
: false;

eval ('
     if (!(ImageTypes() & IMG_'.$img_type_upper.')) {
          DIE ("Das ".$img_type_upper."-Format wird nicht unterstützt!");
     }
     ');

!isset ($x)
? $x = round ($y * $orig_w / $orig_h)
: $x;

!isset ($y)
? $y = round ($x * $orig_h / $orig_w)
: $y;

$thumbf = substr ($img_src, strrpos ($img_src, '/') + 1);
$thumbfile = substr ($thumbf ,0,strrpos($thumbf,'.')) . "x${x}" . "y${y}";
$thumbfile .= substr ($thumbf, strrpos($thumbf, '.'));
if (file_exists ($cachedir."/".$thumbfile)) {
	$thumbdata = getimagesize ($cachedir."/".$thumbfile);
	$thumbdata[0] == $x && $thumbdata[1] == $y
	? $iscached = true
	: $iscached = false;
} else {
	$iscached = false;
}

if (!$iscached) {
	($orig_w > $x || $orig_h > $y) ||
	(($orig_w < $x || $orig_h < $y) && $resize)
	? $makethumb = true
	: $makethumb = false;
} else {
	$makethumb = false;
}

header ("Content-Type: image/".$img_type);

if ($makethumb) {
	$img_path = $cachedir."/".$thumbfile;
	make_thumb($img_path, $img_type, $img_src, $x, $y, $orig_w, $orig_h);
	// if max size is set
	if ($set_max_size == "ON") {
		if (($orig_w > $cf_max_w) or ($orig_h > $cf_max_h)) {
			$thumbfile_max = substr ($thumbf ,0,strrpos($thumbf,'.')) . "x${cf_max_w}" . "y${cf_max_h}";
			$thumbfile_max .= substr ($thumbf, strrpos($thumbf, '.'));
			$img_path_max = $cachedir."/".$thumbfile_max;
			make_thumb($img_path_max, $img_type, $img_src, $cf_max_w, $cf_max_h, $orig_w, $orig_h);
			if ($preserve_orig == "ON") {
				$orig_dir = dirname($img_src). '/original';
				if (!is_dir($orig_dir))	mkdir ($orig_dir, 0777);
				else system ("chmod 0777 ".$orig_dir);
				$filename = basename($img_src);
				$new_src = $orig_dir . '/' . $filename;
				$has_copied = copy($img_src, $new_src);
			}
			$has_copied = copy($img_path_max, $img_src);
			if ($has_copied) {
				unlink($img_path_max);
			} else {
				DIE ($img_path_max.'Bild konnte nicht kopiert werden!');
			}
}
	}
} else {
	$iscached
	? $img_path = $cachedir."/".$thumbfile
	: $img_path = $img_src;
}
$imgp = fopen ($img_path, "rb");
fpassthru ($imgp);
fclose ($imgp);

function make_thumb($img_path, $img_type, $img_src, $x, $y, $orig_w, $orig_h) {
	if ($orig_w > $orig_h) {
		$y = round ($x * $orig_h / $orig_w);
	} else if ($orig_h > $orig_w) {
		$x = round ($y * $orig_w / $orig_h);
	}
	$image = call_user_func("imagecreatefrom".$img_type, $img_src);
	$thumb = imagecreatetruecolor($x, $y);
	if ($img_type == 'png') {
		imagealphablending($thumb, false);
		imagesavealpha($thumb, true);
	}
	imagecopyresampled ($thumb, $image, 0, 0, 0, 0, $x, $y, $orig_w, $orig_h);
	call_user_func("image".$img_type, $thumb, $img_path);
	imagedestroy ($image);
	imagedestroy ($thumb);
}
?>
